Index: tmp/org.txm.setups/nsis/Include/MultiUser.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/MultiUser.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/MultiUser.nsh	(revision 2956)
@@ -4,25 +4,29 @@
 
 Installer configuration for multi-user Windows environments
 
-Copyright 2008-2015 Joost Verburg
+Copyright 2008-2020 Joost Verburg
 
 */
 
 !ifndef MULTIUSER_INCLUDED
-!define MULTIUSER_INCLUDED
-!verbose push
-!verbose 3
+!define MULTIUSER_INCLUDED 20200319
+!verbose push 3
 
 ;Standard NSIS header files
 
 !ifdef MULTIUSER_MUI
   !include MUI2.nsh
 !endif
-!include nsDialogs.nsh
 !include LogicLib.nsh
 !include WinVer.nsh
 !include FileFunc.nsh
 
+!if ${NSIS_PTR_SIZE} > 4
+!define /IfNDef MULTIUSER_MINWIN 0x501
+!else
+!define /IfNDef MULTIUSER_MINWIN 0x400
+!endif
+
 ;Variables
 
 Var MultiUser.Privileges
@@ -68,6 +72,9 @@
   !define MULTIUSER_EXECUTIONLEVEL_ALLUSERS
 !else
   RequestExecutionLevel user
+  !ifndef MULTIUSER_EXECUTIONLEVEL
+    !warning "MULTIUSER_EXECUTIONLEVEL not set!"
+  !endif
 !endif
 
 /*
@@ -91,7 +98,11 @@
     !if "${UNINSTALLER_PREFIX}" != UN
       ;Set default installation location for installer
       !ifdef MULTIUSER_INSTALLMODE_INSTDIR
-        StrCpy $INSTDIR "$PROGRAMFILES\${MULTIUSER_INSTALLMODE_INSTDIR}"
+        !ifdef MULTIUSER_USE_PROGRAMFILES64
+          StrCpy $INSTDIR "$PROGRAMFILES64\${MULTIUSER_INSTALLMODE_INSTDIR}"
+        !else
+          StrCpy $INSTDIR "$PROGRAMFILES\${MULTIUSER_INSTALLMODE_INSTDIR}"
+        !endif
       !endif
     !endif
   
@@ -116,39 +127,46 @@
 !macro MULTIUSER_INSTALLMODE_CURRENTUSER UNINSTALLER_PREFIX UNINSTALLER_FUNCPREFIX
 
   ;Install mode initialization - per-user
-  
-  ${if} ${IsNT}  
-  
+
+  !if ${MULTIUSER_MINWIN} < 0x500
+  ${if} ${IsNT}
+  !endif
+
     StrCpy $MultiUser.InstallMode CurrentUser
-    
     SetShellVarContext current
   
     !if "${UNINSTALLER_PREFIX}" != UN
       ;Set default installation location for installer  
       !ifdef MULTIUSER_INSTALLMODE_INSTDIR
+        !if ${MULTIUSER_MINWIN} < 0x490
         ${if} ${AtLeastWin2000}
-          StrCpy $INSTDIR "$LOCALAPPDATA\${MULTIUSER_INSTALLMODE_INSTDIR}"
+        !endif
+          GetKnownFolderPath $INSTDIR {5CD7AEE2-2219-4A67-B85D-6C9CE15660CB} ; FOLDERID_UserProgramFiles
+          StrCmp $INSTDIR "" 0 +2
+          StrCpy $INSTDIR "$LocalAppData\Programs" ; Fallback directory
+          StrCpy $INSTDIR "$INSTDIR\${MULTIUSER_INSTALLMODE_INSTDIR}"
+        !if ${MULTIUSER_MINWIN} < 0x490
         ${else}
           StrCpy $INSTDIR "$PROGRAMFILES\${MULTIUSER_INSTALLMODE_INSTDIR}"
         ${endif}
+        !endif
       !endif
     !endif
   
     !ifdef MULTIUSER_INSTALLMODE_INSTDIR_REGISTRY_KEY & MULTIUSER_INSTALLMODE_INSTDIR_REGISTRY_VALUENAME
-  
       ReadRegStr $MultiUser.InstDir HKCU "${MULTIUSER_INSTALLMODE_INSTDIR_REGISTRY_KEY}" "${MULTIUSER_INSTALLMODE_INSTDIR_REGISTRY_VALUENAME}"
-  
       ${if} $MultiUser.InstDir != ""
         StrCpy $INSTDIR $MultiUser.InstDir
       ${endif}
-  
     !endif
-  
+
     !ifdef MULTIUSER_INSTALLMODE_${UNINSTALLER_PREFIX}FUNCTION
       Call "${MULTIUSER_INSTALLMODE_${UNINSTALLER_PREFIX}FUNCTION}"
     !endif
-  
+
+  !if ${MULTIUSER_MINWIN} < 0x500
   ${endif}
+  !endif
 
 !macroend
 
@@ -181,26 +199,26 @@
 !macro MULTIUSER_INIT_QUIT UNINSTALLER_FUNCPREFIX
 
   !ifdef MULTIUSER_INIT_${UNINSTALLER_FUNCPREFIX}FUNCTIONQUIT
-    Call "${MULTIUSER_INIT_${UNINSTALLER_FUNCPREFIX}FUCTIONQUIT}
+    Call "${MULTIUSER_INIT_${UNINSTALLER_FUNCPREFIX}FUNCTIONQUIT}"
   !else
     Quit
   !endif
 
 !macroend
 
-!macro MULTIUSER_INIT_TEXTS
+!macro MULTIUSER_INIT_TEXTS UNINSTALLER_PREFIX
 
-  !ifndef MULTIUSER_INIT_TEXT_ADMINREQUIRED
-    !define MULTIUSER_INIT_TEXT_ADMINREQUIRED "$(^Caption) requires administrator priviledges."
+  !if "${UNINSTALLER_PREFIX}" == ""
+    !define /ReDef MULTIUSER_TMPSTR_CAPTION "$(^SetupCaption)"
+  !else
+    !define /ReDef MULTIUSER_TMPSTR_CAPTION "$(^Name)"
   !endif
 
-  !ifndef MULTIUSER_INIT_TEXT_POWERREQUIRED
-    !define MULTIUSER_INIT_TEXT_POWERREQUIRED "$(^Caption) requires at least Power User priviledges."
-  !endif
+  !define /IfNDef MULTIUSER_INIT_TEXT_ADMINREQUIRED "${MULTIUSER_TMPSTR_CAPTION} requires administrator privileges."
+  !define /IfNDef MULTIUSER_INIT_TEXT_POWERREQUIRED "${MULTIUSER_TMPSTR_CAPTION} requires at least Power User privileges."
+  !define /IfNDef MULTIUSER_INIT_TEXT_ALLUSERSNOTPOSSIBLE "Your user account does not have sufficient privileges to install $(^Name) for all users of this computer."
 
-  !ifndef MULTIUSER_INIT_TEXT_ALLUSERSNOTPOSSIBLE
-    !define MULTIUSER_INIT_TEXT_ALLUSERSNOTPOSSIBLE "Your user account does not have sufficient privileges to install $(^Name) for all users of this compuetr."
-  !endif
+  !undef MULTIUSER_TMPSTR_CAPTION
 
 !macroend
 
@@ -208,12 +226,14 @@
 
   ;Installer initialization - check privileges and set install mode
 
-  !insertmacro MULTIUSER_INIT_TEXTS
+  !insertmacro MULTIUSER_INIT_TEXTS "${UNINSTALLER_PREFIX}"
 
   UserInfo::GetAccountType
   Pop $MultiUser.Privileges
   
+  !if ${MULTIUSER_MINWIN} < 0x500
   ${if} ${IsNT}
+  !endif
   
     ;Check privileges
   
@@ -308,46 +328,51 @@
       ${endif}
   
     !endif
-    
+
+  !if ${MULTIUSER_MINWIN} < 0x500
   ${else}
   
     ;Not running Windows NT, per-user installation not supported
-    
     Call ${UNINSTALLER_FUNCPREFIX}MultiUser.InstallMode.AllUsers
-  
+
   ${endif}
+  !endif
 
 !macroend
 
 !macro MULTIUSER_INIT
-  !verbose push
-  !verbose 3
-  
-  !insertmacro MULTIUSER_INIT_CHECKS "" ""
-  
+  !verbose push 3
+  !ifdef __UNINSTALL__
+    !insertmacro MULTIUSER_UNINIT
+  !else
+    !insertmacro MULTIUSER_INIT_CHECKS "" ""
+  !endif
   !verbose pop 
 !macroend
 
 !ifndef MULTIUSER_NOUNINSTALL
-
 !macro MULTIUSER_UNINIT
-  !verbose push
-  !verbose 3
-  
+  !verbose push 3
   !insertmacro MULTIUSER_INIT_CHECKS Un un.
-  
   !verbose pop 
 !macroend
-
 !endif
 
 /*
 
-Modern UI 2 page
+Mode selection page
 
 */
 
-!ifdef MULTIUSER_MUI
+!macro MULTIUSER_PAGE_FUNCTION_CUSTOM TYPE
+  !ifmacrodef MUI_PAGE_FUNCTION_CUSTOM
+    !insertmacro MUI_PAGE_FUNCTION_CUSTOM "${TYPE}"
+  !endif
+  !ifdef MULTIUSER_PAGE_CUSTOMFUNCTION_${TYPE}
+    Call "${MULTIUSER_PAGE_CUSTOMFUNCTION_${TYPE}}"
+    !undef MULTIUSER_PAGE_CUSTOMFUNCTION_${TYPE}
+  !endif
+!macroend
 
 !macro MULTIUSER_INSTALLMODEPAGE_INTERFACE
 
@@ -359,30 +384,30 @@
     
     Var MultiUser.InstallModePage.AllUsers
     Var MultiUser.InstallModePage.CurrentUser
-    
-    Var MultiUser.InstallModePage.ReturnValue
+
   !endif
 
 !macroend
 
-!macro MULTIUSER_PAGEDECLARATION_INSTALLMODE
+!macro MULTIUSER_PAGEDECLARATION_INSTALLMODE UNPREFIX UNIQUEID
 
-  !insertmacro MUI_SET MULTIUSER_${MUI_PAGE_UNINSTALLER_PREFIX}INSTALLMODEPAGE ""
+  !define /ReDef MULTIUSER_${UNPREFIX}INSTALLMODEPAGE "" ; Unlock strings in the language file(s)
   !insertmacro MULTIUSER_INSTALLMODEPAGE_INTERFACE
 
-  !insertmacro MUI_DEFAULT MULTIUSER_INSTALLMODEPAGE_TEXT_TOP "$(MULTIUSER_INNERTEXT_INSTALLMODE_TOP)"
-  !insertmacro MUI_DEFAULT MULTIUSER_INSTALLMODEPAGE_TEXT_ALLUSERS "$(MULTIUSER_INNERTEXT_INSTALLMODE_ALLUSERS)"
-  !insertmacro MUI_DEFAULT MULTIUSER_INSTALLMODEPAGE_TEXT_CURRENTUSER "$(MULTIUSER_INNERTEXT_INSTALLMODE_CURRENTUSER)"  
+  !define /IfNDef MULTIUSER_INSTALLMODEPAGE_TEXT_TOP "$(MULTIUSER_INNERTEXT_INSTALLMODE_TOP)"
+  !define /IfNDef MULTIUSER_INSTALLMODEPAGE_TEXT_ALLUSERS "$(MULTIUSER_INNERTEXT_INSTALLMODE_ALLUSERS)"
+  !define /IfNDef MULTIUSER_INSTALLMODEPAGE_TEXT_CURRENTUSER "$(MULTIUSER_INNERTEXT_INSTALLMODE_CURRENTUSER)"  
 
   PageEx custom
 
-    PageCallbacks MultiUser.InstallModePre_${MUI_UNIQUEID} MultiUser.InstallModeLeave_${MUI_UNIQUEID}
+    PageCallbacks MultiUser.InstallModePre_${UNIQUEID} MultiUser.InstallModeLeave_${UNIQUEID}
 
-    Caption " "
+    !define /IfNDef MULTIUSER_INSTALLMODEPAGE_CAPTION " "
+    Caption "${MULTIUSER_INSTALLMODEPAGE_CAPTION}"
 
   PageExEnd
 
-  !insertmacro MULTIUSER_FUNCTION_INSTALLMODEPAGE MultiUser.InstallModePre_${MUI_UNIQUEID} MultiUser.InstallModeLeave_${MUI_UNIQUEID}
+  !insertmacro MULTIUSER_FUNCTION_INSTALLMODEPAGE MultiUser.InstallModePre_${UNIQUEID} MultiUser.InstallModeLeave_${UNIQUEID}
 
   !undef MULTIUSER_INSTALLMODEPAGE_TEXT_TOP
   !undef MULTIUSER_INSTALLMODEPAGE_TEXT_ALLUSERS
@@ -392,78 +417,92 @@
 
 !macro MULTIUSER_PAGE_INSTALLMODE
 
-  ;Modern UI page for install mode
-
-  !verbose push
-  !verbose 3
+  !verbose push 3
   
   !ifndef MULTIUSER_EXECUTIONLEVEL_ALLUSERS
     !error "A mixed-mode installation requires MULTIUSER_EXECUTIONLEVEL to be set to Admin, Power or Highest."
   !endif
+
+  !ifmacrodef MUI_PAGE_INIT
+    !insertmacro MUI_PAGE_INIT
+  !endif
+  !insertmacro MULTIUSER_PAGEDECLARATION_INSTALLMODE "" ${__COUNTER__}
   
-  !insertmacro MUI_PAGE_INIT
-  !insertmacro MULTIUSER_PAGEDECLARATION_INSTALLMODE
-  
   !verbose pop
 
 !macroend
 
 !macro MULTIUSER_FUNCTION_INSTALLMODEPAGE PRE LEAVE
 
-  ;Page functions of Modern UI page
+  !include nsDialogs.nsh
 
   Function "${PRE}"
-  
+
+    !if ${MULTIUSER_MINWIN} < 0x500
     ${ifnot} ${IsNT}
       Abort
     ${endif}
-  
+    !endif
+
     ${if} $MultiUser.Privileges != "Power"
       ${andif} $MultiUser.Privileges != "Admin"
       Abort
     ${endif}
-    
-    !insertmacro MUI_PAGE_FUNCTION_CUSTOM PRE
-    !insertmacro MUI_HEADER_TEXT_PAGE $(MULTIUSER_TEXT_INSTALLMODE_TITLE) $(MULTIUSER_TEXT_INSTALLMODE_SUBTITLE)
-    
+
+    !insertmacro MULTIUSER_PAGE_FUNCTION_CUSTOM PRE
+    !ifmacrodef MUI_HEADER_TEXT_PAGE
+      !insertmacro MUI_HEADER_TEXT_PAGE $(MULTIUSER_TEXT_INSTALLMODE_TITLE) $(MULTIUSER_TEXT_INSTALLMODE_SUBTITLE)
+    !endif
+
     nsDialogs::Create 1018
     Pop $MultiUser.InstallModePage
 
-    ${NSD_CreateLabel} 0u 0u 300u 20u "${MULTIUSER_INSTALLMODEPAGE_TEXT_TOP}"
+    ${NSD_CreateLabel} 0 2u 100% 42u "${MULTIUSER_INSTALLMODEPAGE_TEXT_TOP}"
     Pop $MultiUser.InstallModePage.Text
 
-    ${NSD_CreateRadioButton} 20u 50u 280u 10u "${MULTIUSER_INSTALLMODEPAGE_TEXT_ALLUSERS}"
+    ${NSD_CreateRadioButton} 15u 50u -15u 10u "${MULTIUSER_INSTALLMODEPAGE_TEXT_ALLUSERS}"
     Pop $MultiUser.InstallModePage.AllUsers
-    
-    ${NSD_CreateRadioButton} 20u 70u 280u 10u "${MULTIUSER_INSTALLMODEPAGE_TEXT_CURRENTUSER}"
+
+    !ifdef MULTIUSER_INSTALLMODEPAGE_SHOWUSERNAME
+    !ifdef NOSYSTEMCALLS
+    ReadEnvStr $0 USERNAME
+    !else
+    System::Call 'ADVAPI32::GetUserName(t""r0,*i${NSIS_MAX_STRLEN})'
+    !endif
+    StrCmp $0 "" +2
+      StrCpy $0 " ($0)"
+    ${NSD_CreateRadioButton} 15u 70u -15u 10u "${MULTIUSER_INSTALLMODEPAGE_TEXT_CURRENTUSER}$0"
+    !else
+    ${NSD_CreateRadioButton} 15u 70u -15u 10u "${MULTIUSER_INSTALLMODEPAGE_TEXT_CURRENTUSER}"
+    !endif
     Pop $MultiUser.InstallModePage.CurrentUser
-    
+
     ${if} $MultiUser.InstallMode == "AllUsers"
       SendMessage $MultiUser.InstallModePage.AllUsers ${BM_SETCHECK} ${BST_CHECKED} 0
     ${else}
       SendMessage $MultiUser.InstallModePage.CurrentUser ${BM_SETCHECK} ${BST_CHECKED} 0
     ${endif}
     
-    !insertmacro MUI_PAGE_FUNCTION_CUSTOM SHOW
+    !insertmacro MULTIUSER_PAGE_FUNCTION_CUSTOM SHOW
     nsDialogs::Show
+    !insertmacro MULTIUSER_PAGE_FUNCTION_CUSTOM DESTROYED
     
   FunctionEnd
 
   Function "${LEAVE}"
-     SendMessage $MultiUser.InstallModePage.AllUsers ${BM_GETCHECK} 0 0 $MultiUser.InstallModePage.ReturnValue
+     SendMessage $MultiUser.InstallModePage.AllUsers ${BM_GETCHECK} 0 0 $0
      
-     ${if} $MultiUser.InstallModePage.ReturnValue = ${BST_CHECKED}
+     ${if} $0 = ${BST_CHECKED}
         Call MultiUser.InstallMode.AllUsers
      ${else}
         Call MultiUser.InstallMode.CurrentUser
      ${endif}
   
-    !insertmacro MUI_PAGE_FUNCTION_CUSTOM LEAVE
+    !insertmacro MULTIUSER_PAGE_FUNCTION_CUSTOM LEAVE
   FunctionEnd
 
 !macroend
 
-!endif
 
 !verbose pop
 !endif
Index: tmp/org.txm.setups/nsis/Include/FileFunc.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/FileFunc.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/FileFunc.nsh	(revision 2956)
@@ -67,24 +67,20 @@
 ; ${FILEFUNC_VERBOSE} 3   # no script
 
 !ifndef FILEFUNC_INCLUDED
+
+!verbose push 3
+!define /IfNDef _FILEFUNC_VERBOSE 3
+!verbose ${_FILEFUNC_VERBOSE}
+!define FILEFUNC_VERBOSE `!insertmacro FILEFUNC_VERBOSE`
+
 !define FILEFUNC_INCLUDED
 
 !include Util.nsh
 
-!verbose push
-!verbose 3
-!ifndef _FILEFUNC_VERBOSE
-	!define _FILEFUNC_VERBOSE 3
-!endif
-!verbose ${_FILEFUNC_VERBOSE}
-!define FILEFUNC_VERBOSE `!insertmacro FILEFUNC_VERBOSE`
-!verbose pop
 
 !macro FILEFUNC_VERBOSE _VERBOSE
-	!verbose push
-	!verbose 3
-	!undef _FILEFUNC_VERBOSE
-	!define _FILEFUNC_VERBOSE ${_VERBOSE}
+	!verbose push 3
+	!define /ReDef _FILEFUNC_VERBOSE ${_VERBOSE}
 	!verbose pop
 !macroend
 
@@ -910,7 +906,7 @@
 	StrCpy $6 1073741824
 
 	FileFunc_DriveSpace_getspace:
-	System::Call 'kernel32::GetDiskFreeSpaceExA(t, *l, *l, *l)i(r0,.r2,.r3,.)'
+	System::Call 'kernel32::GetDiskFreeSpaceEx(t, *l, *l, *l)i(r0,.r2,.r3,.)'
 
 	StrCmp $5 T 0 +3
 	StrCpy $0 $3
@@ -968,9 +964,9 @@
 	Push $8
 	Push $9
 
-	System::Alloc 1024
+	System::StrAlloc 1024
 	Pop $2
-	System::Call 'kernel32::GetLogicalDriveStringsA(i,i) i(1024, r2)'
+	System::Call 'kernel32::GetLogicalDriveStrings(i,i) i(1024, r2)'
 
 	StrCmp $0 ALL FileFunc_GetDrives_drivestring
 	StrCmp $0 '' 0 FileFunc_GetDrives_typeset
@@ -1007,10 +1003,10 @@
 	StrCpy $3 $2
 
 	FileFunc_GetDrives_enumok:
-	System::Call 'kernel32::lstrlenA(t) i(i r3) .r4'
+	System::Call 'kernel32::lstrlen(t) i(i r3) .r4'
 	StrCmp $4$0 '0ALL' FileFunc_GetDrives_enumex
 	StrCmp $4 0 FileFunc_GetDrives_typeset
-	System::Call 'kernel32::GetDriveTypeA(t) i(i r3) .r5'
+	System::Call 'kernel32::GetDriveType(t) i(i r3) .r5'
 
 	StrCmp $0 ALL +2
 	StrCmp $5 $6 FileFunc_GetDrives_letter FileFunc_GetDrives_enumnext
@@ -1053,8 +1049,9 @@
 	StrCmp $9 'StopGetDrives' FileFunc_GetDrives_enumex
 
 	FileFunc_GetDrives_enumnext:
+	IntOp $4 $4 * ${NSIS_CHAR_SIZE}
 	IntOp $3 $3 + $4
-	IntOp $3 $3 + 1
+	IntOp $3 $3 + ${NSIS_CHAR_SIZE}
 	goto FileFunc_GetDrives_enumok
 
 	FileFunc_GetDrives_enumex:
@@ -1110,22 +1107,22 @@
 
 	FileFunc_GetTime_getfile:
 	IfFileExists $0 0 FileFunc_GetTime_error
-	System::Call '*(i,l,l,l,i,i,i,i,&t260,&t14) i .r6'
-	System::Call 'kernel32::FindFirstFileA(t,i)i(r0,r6) .r2'
+	System::Call '*(i,l,l,l,i,i,i,i,&t260,&t14) p .r6'
+	System::Call 'kernel32::FindFirstFile(t,p)p(r0,r6) .r2'
 	System::Call 'kernel32::FindClose(i)i(r2)'
 
 	FileFunc_GetTime_gettime:
-	System::Call '*(&i2,&i2,&i2,&i2,&i2,&i2,&i2,&i2) i .r7'
+	System::Call '*(&i2,&i2,&i2,&i2,&i2,&i2,&i2,&i2) p .r7'
 	StrCmp $1 'L' 0 FileFunc_GetTime_systemtime
-	System::Call 'kernel32::GetLocalTime(i)i(r7)'
+	System::Call 'kernel32::GetLocalTime(p)i(r7)'
 	goto FileFunc_GetTime_convert
 	FileFunc_GetTime_systemtime:
 	StrCmp $1 'LS' 0 FileFunc_GetTime_filetime
-	System::Call 'kernel32::GetSystemTime(i)i(r7)'
+	System::Call 'kernel32::GetSystemTime(p)i(r7)'
 	goto FileFunc_GetTime_convert
 
 	FileFunc_GetTime_filetime:
-	System::Call '*$6(i,l,l,l,i,i,i,i,&t260,&t14)i(,.r4,.r3,.r2)'
+	System::Call '*$6(i,l,l,l,i,i,i,i,&t260,&t14)p(,.r4,.r3,.r2)'
 	System::Free $6
 	StrCmp $1 'A' 0 +3
 	StrCpy $2 $3
@@ -1149,7 +1146,7 @@
 	System::Call 'kernel32::FileTimeToSystemTime(*l,i)i(r3,r7)'
 
 	FileFunc_GetTime_convert:
-	System::Call '*$7(&i2,&i2,&i2,&i2,&i2,&i2,&i2,&i2)i(.r5,.r6,.r4,.r0,.r3,.r2,.r1,)'
+	System::Call '*$7(&i2,&i2,&i2,&i2,&i2,&i2,&i2,&i2)p(.r5,.r6,.r4,.r0,.r3,.r2,.r1,)'
 	System::Free $7
 
 	IntCmp $0 9 0 0 +2
@@ -1401,8 +1398,8 @@
 	Push $0
 	Push $1
 	Push $2
-	System::Call 'kernel32::GetModuleFileNameA(i 0, t .r0, i 1024)'
-	System::Call 'kernel32::GetLongPathNameA(t r0, t .r1, i 1024)i .r2'
+	System::Call 'kernel32::GetModuleFileName(p 0, t .r0, i 1024)'
+	System::Call 'kernel32::GetLongPathName(t r0, t .r1, i 1024)i .r2'
 	StrCmp $2 error +2
 	StrCpy $0 $1
 	Pop $2
@@ -1429,7 +1426,7 @@
 	Push $1
 	Push $2
 	StrCpy $0 $EXEDIR
-	System::Call 'kernel32::GetLongPathNameA(t r0, t .r1, i 1024)i .r2'
+	System::Call 'kernel32::GetLongPathName(t r0, t .r1, i 1024)i .r2'
 	StrCmp $2 error +2
 	StrCpy $0 $1
 	Pop $2
@@ -2014,4 +2011,5 @@
 	!verbose pop
 !macroend
 
+!verbose pop
 !endif
Index: tmp/org.txm.setups/nsis/Include/TextFunc.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/TextFunc.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/TextFunc.nsh	(revision 2956)
@@ -54,25 +54,21 @@
 ; ${TEXTFUNC_VERBOSE} 3   # no script
 
 !ifndef TEXTFUNC_INCLUDED
+
+!verbose push 3
+!define /IfNDef _TEXTFUNC_VERBOSE 3
+!verbose ${_TEXTFUNC_VERBOSE}
+!define TEXTFUNC_VERBOSE `!insertmacro TEXTFUNC_VERBOSE`
+
 !define TEXTFUNC_INCLUDED
 
 !include FileFunc.nsh
 !include Util.nsh
 
-!verbose push
-!verbose 3
-!ifndef _TEXTFUNC_VERBOSE
-	!define _TEXTFUNC_VERBOSE 3
-!endif
-!verbose ${_TEXTFUNC_VERBOSE}
-!define TEXTFUNC_VERBOSE `!insertmacro TEXTFUNC_VERBOSE`
-!verbose pop
 
 !macro TEXTFUNC_VERBOSE _VERBOSE
-	!verbose push
-	!verbose 3
-	!undef _TEXTFUNC_VERBOSE
-	!define _TEXTFUNC_VERBOSE ${_VERBOSE}
+	!verbose push 3
+	!define /ReDef _TEXTFUNC_VERBOSE ${_VERBOSE}
 	!verbose pop
 !macroend
 
@@ -1047,12 +1043,12 @@
 	System::Alloc $6
 	Pop $0
 	FileSeek $3 $5 SET
-	System::Call 'kernel32::ReadFile(i r3, i r0, i $6, t.,)'
+	System::Call 'kernel32::ReadFile(p r3, p r0, i $6, t.,)'
 	FileSeek $3 $4 SET
 	StrCmp${_TEXTFUNC_S} $2 '' +2
 	FileWrite $3 '$1$2$\r$\n'
-	System::Call 'kernel32::WriteFile(i r3, i r0, i $6, t.,)'
-	System::Call 'kernel32::SetEndOfFile(i r3)'
+	System::Call 'kernel32::WriteFile(p r3, p r0, i $6, t.,)'
+	System::Call 'kernel32::SetEndOfFile(p r3)'
 	System::Free $0
 	StrCmp${_TEXTFUNC_S} $2 '' +3
 	StrCpy $0 CHANGED
@@ -1157,10 +1153,10 @@
 	System::Alloc $3
 	Pop $4
 	FileSeek $2 0 SET
-	System::Call 'kernel32::ReadFile(i r2, i r4, i $3, t.,)'
-	System::Call 'user32::$1Buff(i r4, i r4, i $3)'
+	System::Call 'kernel32::ReadFile(p r2, p r4, i $3, t.,)'
+	System::Call 'user32::$1Buff(p r4, p r4, i $3)'
 	FileSeek $2 0 SET
-	System::Call 'kernel32::WriteFile(i r2, i r4, i $3, t.,)'
+	System::Call 'kernel32::WriteFile(p r2, p r4, i $3, t.,)'
 	System::Free $4
 	FileClose $2
 	goto TextFunc_FileRecode_end
@@ -1211,4 +1207,5 @@
 	!verbose pop
 !macroend
 
+!verbose pop
 !endif
Index: tmp/org.txm.setups/nsis/Include/VB6RunTime.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/VB6RunTime.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/VB6RunTime.nsh	(revision 2956)
@@ -4,10 +4,10 @@
 
 Setup of Visual Basic 6.0 run-time files, including the Oleaut32.dll security update
 
-Copyright 2008-2015 Joost Verburg
+Copyright 2008-2020 Joost Verburg
 
 To obtain the run-time files, download and extract
-http://nsis.sourceforge.net/vb6runtime.zip
+https://nsis.sourceforge.io/vb6runtime.zip
 
 Script code for installation:
 
Index: tmp/org.txm.setups/nsis/Include/Library.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/Library.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/Library.nsh	(revision 2956)
@@ -121,11 +121,15 @@
   ;------------------------
   ;Setup RegTool
 
+  !if ! /FileExists "${NSISDIR}\Bin\RegTool-${NSIS_CPU}.bin"
+    !error "Missing RegTool for ${NSIS_CPU}!"
+  !endif
+
   ReadRegStr $R3 HKLM "Software\Microsoft\Windows\CurrentVersion\RunOnce" "${REGTOOL_KEY}"
   StrCpy $R3 $R3 -4 1
   IfFileExists $R3 +3
 
-    File /oname=$R2\${REGTOOL_KEY}.$__INSTALLLLIB_SESSIONGUID.exe "${NSISDIR}\Bin\RegTool.bin"
+    File /oname=$R2\${REGTOOL_KEY}.$__INSTALLLLIB_SESSIONGUID.exe "${NSISDIR}\Bin\RegTool-${NSIS_CPU}.bin"
     WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\RunOnce" \
       "${REGTOOL_KEY}" '"$R2\${REGTOOL_KEY}.$__INSTALLLLIB_SESSIONGUID.exe" /S'
 
@@ -142,31 +146,31 @@
 
 !macroend
 
-### Get library version
-!macro __InstallLib_Helper_GetVersion TYPE FILE
+!macro __InstallLib_Helper_CmpPackedVer64 oldhi oldlo newhi newlo jeq jle jgt
 
-  !tempfile LIBRARY_TEMP_NSH
+  IntCmpU ${oldhi} ${newhi} "0"      "${jle}" "${jgt}"
+  IntCmpU ${oldlo} ${newlo} "${jeq}" "${jle}" "${jgt}"
 
-  !ifdef NSIS_WIN32_MAKENSIS
+!macroend
 
-    !execute '"${NSISDIR}\Bin\LibraryLocal.exe" "${TYPE}" "${FILE}" "${LIBRARY_TEMP_NSH}"'
+### Get library version
+!macro __InstallLib_Helper_GetVersion TYPE FILE
 
-  !else
+  !if "${TYPE}" == "D"
+   !getdllversion /NoErrors /Packed "${FILE}" LIBRARY_VERSION_
+  !else if "${TYPE}" == "T"
+    !gettlbversion /NoErrors /Packed "${FILE}" LIBRARY_VERSION_
+  !endif
 
-    !execute 'LibraryLocal "${TYPE}" "${FILE}" "${LIBRARY_TEMP_NSH}"'
-
-    !if ${TYPE} == 'T'
-
-      !warning "LibraryLocal currently supports TypeLibs version detection on Windows only"
-
-    !endif
-
+  ; Emulate the old LibraryLocal defines
+  !ifndef LIBRARY_VERSION_HIGH
+    !define LIBRARY_VERSION_FILENOTFOUND
+  !else if "${LIBRARY_VERSION_HIGH}" == ""
+    !define LIBRARY_VERSION_NONE
+    !undef LIBRARY_VERSION_HIGH
+    !undef LIBRARY_VERSION_LOW
   !endif
 
-  !include "${LIBRARY_TEMP_NSH}"
-  !delfile "${LIBRARY_TEMP_NSH}"
-  !undef LIBRARY_TEMP_NSH
-
 !macroend
 
 ### Install library
@@ -300,9 +304,13 @@
 
       !ifndef INSTALLLIB_LIBTYPE_TLB & INSTALLLIB_LIBTYPE_REGDLLTLB
 
-        IntCmpU $R0 $R2 0 "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.upgrade_${INSTALLLIB_UNIQUE}"
-        IntCmpU $R1 $R3 "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.register_${INSTALLLIB_UNIQUE}" \
-          "installlib.upgrade_${INSTALLLIB_UNIQUE}"
+        !ifdef LIBRARY_INSTALL_EQUAL_VERSION
+          !insertmacro __InstallLib_Helper_CmpPackedVer64 $R0 $R1 $R2 $R3 "installlib.upgrade_${INSTALLLIB_UNIQUE}" \
+            "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.upgrade_${INSTALLLIB_UNIQUE}"
+        !else
+          !insertmacro __InstallLib_Helper_CmpPackedVer64 $R0 $R1 $R2 $R3 "installlib.register_${INSTALLLIB_UNIQUE}" \
+            "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.upgrade_${INSTALLLIB_UNIQUE}"
+        !endif
 
       !else
 
@@ -314,15 +322,18 @@
 
         !ifndef LIBRARY_VERSION_NONE
 
-          IntCmpU $R0 $R2 0 "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.upgrade_${INSTALLLIB_UNIQUE}"
-          IntCmpU $R1 $R3 0 "installlib.register_${INSTALLLIB_UNIQUE}" \
-            "installlib.upgrade_${INSTALLLIB_UNIQUE}"
+          !insertmacro __InstallLib_Helper_CmpPackedVer64 $R0 $R1 $R2 $R3 0 \
+            "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.upgrade_${INSTALLLIB_UNIQUE}"
 
         !else
 
-          IntCmpU $R0 $R2 0 "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.upgrade_${INSTALLLIB_UNIQUE}"
-          IntCmpU $R1 $R3 "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.register_${INSTALLLIB_UNIQUE}" \
-            "installlib.upgrade_${INSTALLLIB_UNIQUE}"
+          !ifdef LIBRARY_INSTALL_EQUAL_VERSION
+            !insertmacro __InstallLib_Helper_CmpPackedVer64 $R0 $R1 $R2 $R3 "installlib.upgrade_${INSTALLLIB_UNIQUE}" \
+              "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.upgrade_${INSTALLLIB_UNIQUE}"
+          !else
+            !insertmacro __InstallLib_Helper_CmpPackedVer64 $R0 $R1 $R2 $R3 "installlib.register_${INSTALLLIB_UNIQUE}" \
+              "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.upgrade_${INSTALLLIB_UNIQUE}"
+          !endif
 
         !endif
 
@@ -363,9 +374,13 @@
         Pop $R3
         Pop $R2
 
-        IntCmpU $R0 $R2 0 "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.upgrade_${INSTALLLIB_UNIQUE}"
-        IntCmpU $R1 $R3 "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.register_${INSTALLLIB_UNIQUE}" \
-          "installlib.upgrade_${INSTALLLIB_UNIQUE}"
+        !ifdef LIBRARY_INSTALL_EQUAL_VERSION
+          !insertmacro __InstallLib_Helper_CmpPackedVer64 $R0 $R1 $R2 $R3 "installlib.upgrade_${INSTALLLIB_UNIQUE}" \
+            "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.upgrade_${INSTALLLIB_UNIQUE}"
+        !else
+          !insertmacro __InstallLib_Helper_CmpPackedVer64 $R0 $R1 $R2 $R3 "installlib.register_${INSTALLLIB_UNIQUE}" \
+            "installlib.register_${INSTALLLIB_UNIQUE}" "installlib.upgrade_${INSTALLLIB_UNIQUE}"
+        !endif
 
         !undef LIBRARY_VERSION_HIGH
         !undef LIBRARY_VERSION_LOW
@@ -378,7 +393,7 @@
 
     !endif
 
-  !endif
+  !endif ;~LIBRARY_IGNORE_VERSION
 
   ;------------------------
   ;Upgrade
Index: tmp/org.txm.setups/nsis/COPYING
===================================================================
--- tmp/org.txm.setups/nsis/COPYING	(revision 2955)
+++ tmp/org.txm.setups/nsis/COPYING	(revision 2956)
@@ -1,7 +1,7 @@
 COPYRIGHT
 ---------
 
-Copyright (C) 1995-2015 Contributors
+Copyright (C) 1999-2020 Contributors
 
 More detailed copyright information can be found in the individual source code files.
 
Index: tmp/org.txm.setups/nsis/Docs/Modern UI 2/License.txt
===================================================================
--- tmp/org.txm.setups/nsis/Docs/Modern UI 2/License.txt	(revision 2955)
+++ tmp/org.txm.setups/nsis/Docs/Modern UI 2/License.txt	(revision 2956)
@@ -1,4 +1,4 @@
-Copyright © 2002-2015 Joost Verburg
+Copyright © 2002-2020 Joost Verburg
 
 This software is provided 'as-is', without any express or implied warranty. In no event will the authors be held liable for any damages arising from the use of this software.
 
